﻿Imports System.Xml
Imports OSGeo.OGR
Imports OSGeo.OSR

Public Class DataSourceInfo
    Public ds As OSGeo.OGR.DataSource
    Private wTrNode As TreeNode
    Private wXML As XmlDocument

    Sub New(dsFileName As String)
        ds = Ogr.Open(dsFileName, 0)
        'wTrNode = New TreeNode '!!!
        If ds Is Nothing Then Me.Finalize()
    End Sub

    Public Sub FillNode(ByRef wTrNd As TreeNode)
        'wTrNode = wTrNd
        'wTrNode.Nodes.Add("Driver")
        Dim wTreeNode As TreeNode
        wXML = New XmlDocument
        wXML.LoadXml("<?xml version='1.0' ?> <root/>")
        Dim root As XmlElement = wXML.DocumentElement
        root.AppendChild(Me.GetXML(wXML))
        '
        wTreeNode = wTrNd.Nodes.Add(wXML.DocumentElement.Name)
        wTreeNode.Tag = wXML.DocumentElement
        If wXML.DocumentElement.HasChildNodes Then FillChildTree(wXML.DocumentElement, wTreeNode)
    End Sub

    Private Sub FillChildTree(ByRef crNode As XmlNode, ByRef wTreeNode As TreeNode)
        Dim I As Integer
        Dim chTreeNode As TreeNode
        Dim chNode As XmlNode
        For I = 0 To crNode.ChildNodes.Count - 1
            chNode = crNode.ChildNodes.Item(I)
            If chNode.NodeType = XmlNodeType.Text Then
                chTreeNode = wTreeNode.Nodes.Add(chNode.Value)
            Else
                chTreeNode = wTreeNode.Nodes.Add(chNode.Name)
            End If
            chTreeNode.Tag = chNode
            If chNode.HasChildNodes Then FillChildTree(chNode, chTreeNode)
        Next I
    End Sub

    Public Function GetXML(XMLDoc As XmlDocument) As XmlElement
        Dim root As XmlElement
        Dim wNode, subNode As XmlNode
        'wNode = XMLDoc.CreateTextNode(ds.GetName)
        'root = 
        root = XMLDoc.CreateElement("DataSource")
        wNode = XMLDoc.CreateElement("Name")
        wNode.InnerText = ds.GetName
        root.AppendChild(wNode)
        '
        wNode = XMLDoc.CreateElement("Driver")
        wNode.InnerText = ds.GetDriver.GetName
        root.AppendChild(wNode)
        wNode = XMLDoc.CreateElement("Layers")
        root.AppendChild(wNode)
        Dim iLayer As Integer
        Dim wLayer As Layer
        For iLayer = 0 To ds.GetLayerCount - 1
            wLayer = ds.GetLayerByIndex(iLayer)
            If wLayer Is Nothing Then
                subNode = XMLDoc.CreateElement("Layer")
                subNode.InnerText = "FAILURE: Couldn't fetch advertised layer: " + iLayer
                wNode.AppendChild(subNode)
            Else
                subNode = GetLayerXML(XMLDoc, wLayer)
                wNode.AppendChild(subNode)
            End If
        Next iLayer
        Return root
    End Function

    Public Function GetLayerXML(XMLDoc As XmlDocument, wLayer As Layer) As XmlElement
        Dim root As XmlElement
        Dim wNode, wNode1, subNode As XmlNode
        Dim def As FeatureDefn = wLayer.GetLayerDefn()
        '
        root = XMLDoc.CreateElement("Layer")
        wNode = XMLDoc.CreateElement("Name")
        wNode.InnerText = wLayer.GetName
        root.AppendChild(wNode)
        '
        wNode = XMLDoc.CreateElement("GeomType")
        wNode.InnerText = def.GetGeomType.ToString
        root.AppendChild(wNode)
        '
        wNode = XMLDoc.CreateElement("Feature_Count")
        wNode.InnerText = wLayer.GetFeatureCount(1).ToString
        root.AppendChild(wNode)
        '
        Dim ext As Envelope = New Envelope()
        wLayer.GetExtent(ext, 1)
        root.AppendChild(GetExtentXML(XMLDoc, ext)) '?!
        '
        Dim sr As SpatialReference = wLayer.GetSpatialRef()
        Dim srs_wkt As String = "(unknown)"
        '
        If Not (sr Is Nothing) Then
            sr.ExportToPrettyWkt(srs_wkt, 1)
        End If
        '
        wNode = XMLDoc.CreateElement("SRS_WKT")
        wNode.InnerText = srs_wkt
        root.AppendChild(wNode)
        '
        wNode = XMLDoc.CreateElement("Field_definition")
        root.AppendChild(wNode)
        '
        Dim iAttr As Integer
        Dim fdef As FieldDefn
        For iAttr = 0 To def.GetFieldCount() - 1
            fdef = def.GetFieldDefn(iAttr)
            '
            wNode1 = XMLDoc.CreateElement("Field")
            wNode.AppendChild(wNode1)
            '
            subNode = XMLDoc.CreateElement("Name")
            subNode.InnerText = fdef.GetNameRef()
            wNode1.AppendChild(subNode)
            '
            subNode = XMLDoc.CreateElement("FieldType")
            subNode.InnerText = fdef.GetFieldType().ToString
            wNode1.AppendChild(subNode)
            '
            subNode = XMLDoc.CreateElement("Width")
            subNode.InnerText = fdef.GetWidth().ToString
            wNode1.AppendChild(subNode)
            '
            subNode = XMLDoc.CreateElement("Precision")
            subNode.InnerText = fdef.GetPrecision().ToString
            wNode1.AppendChild(subNode)
        Next iAttr
        Return root
    End Function

    Function GetExtentXML(XMLDoc As XmlDocument, ext As Envelope) As XmlNode
        Dim wNode, subNode As XmlNode
        wNode = XMLDoc.CreateElement("Extent")
        '
        subNode = XMLDoc.CreateElement("MinX")
        subNode.InnerText = ext.MinX.ToString
        wNode.AppendChild(subNode)
        '
        subNode = XMLDoc.CreateElement("MaxX")
        subNode.InnerText = ext.MaxX.ToString
        wNode.AppendChild(subNode)
        '
        subNode = XMLDoc.CreateElement("MinY")
        subNode.InnerText = ext.MinY.ToString
        wNode.AppendChild(subNode)
        '
        subNode = XMLDoc.CreateElement("MaxY")
        subNode.InnerText = ext.MaxY.ToString
        wNode.AppendChild(subNode)
        Return wNode
    End Function

    Public Function Gettest1XML(XMLDoc As XmlDocument, field1 As String, field2 As String) As XmlElement
        Dim root As XmlElement
        Dim wNode, subNode As XmlNode

        root = XMLDoc.CreateElement("test")
        wNode = XMLDoc.CreateElement("Layers")
        root.AppendChild(wNode)
        Dim iLayer As Integer
        Dim wLayer As Layer
        For iLayer = 0 To ds.GetLayerCount - 1
            wLayer = ds.GetLayerByIndex(iLayer)
            If wLayer Is Nothing Then
                subNode = XMLDoc.CreateElement("Layer")
                subNode.InnerText = "FAILURE: Couldn't fetch advertised layer: " + iLayer
                wNode.AppendChild(subNode)
            Else
                subNode = GetTest1(XMLDoc, wLayer, field1, field2)
                wNode.AppendChild(subNode)
            End If
        Next iLayer
        Return root
    End Function

    Function GetTest1(XMLDoc As XmlDocument, wLayer As Layer, field1 As String, field2 As String) As XmlElement
        '
        Dim feat As Feature = wLayer.GetNextFeature()
        Dim root, nElem As XmlElement
        Dim tNode As XmlNode
        root = XMLDoc.CreateElement("test1")
        While Not (feat) Is Nothing '!
            nElem = test1Feature(XMLDoc, feat, wLayer.GetLayerDefn(), wLayer.GetName, field1, field2)
            If nElem.ChildNodes.Count > 1 Then
                tNode = root.SelectSingleNode("descendant::value1[" & field1 & "=""" & nElem.ChildNodes.Item(1).InnerText & """]")
                If tNode Is Nothing Then root.AppendChild(nElem)
            End If
            feat.Dispose()
            feat = wLayer.GetNextFeature()
        End While
        Return root
    End Function

    Function test1Feature(XMLDoc As XmlDocument, feat As Feature, def As FeatureDefn, LayerName As String, field1 As String, field2 As String) As XmlElement
        Dim iField As Integer
        Dim root As XmlElement
        Dim wNode As XmlNode
        root = XMLDoc.CreateElement("value1")
        wNode = XMLDoc.CreateElement("LayerName")
        wNode.InnerText = LayerName
        root.AppendChild(wNode)
        iField = feat.GetFieldIndex(field1)
        If Not (iField = -1) Then
            wNode = XMLDoc.CreateElement(field1)
            wNode.InnerText = feat.GetFieldAsString(iField)
            root.AppendChild(wNode)
            iField = feat.GetFieldIndex(field2)
            If Not (iField = -1) Then
                wNode = XMLDoc.CreateElement(field2)
                wNode.InnerText = feat.GetFieldAsString(iField)
                root.AppendChild(wNode)
            End If
        End If
        Return root
    End Function

End Class
